/*!
 * Tozny e3db
 *
 * LICENSE
 *
 * Tozny dual licenses this product. For commercial use, please contact
 * info@tozny.com. For non-commercial use, the contents of this file are
 * subject to the TOZNY NON-COMMERCIAL LICENSE (the "License") which
 * permits use of the software only by government agencies, schools,
 * universities, non-profit organizations or individuals on projects that
 * do not receive external funding other than government research grants
 * and contracts.  Any other use requires a commercial license. You may
 * not use this file except in compliance with the License. You may obtain
 * a copy of the License at https://tozny.com/legal/non-commercial-license.
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the
 * License for the specific language governing rights and limitations under
 * the License. Portions of the software are Copyright (c) TOZNY LLC, 2018-19.
 * All rights reserved.
 *
 * @copyright Copyright (c) 2018-19 Tozny, LLC (https://tozny.com)
 */

'use strict';

/**
 * Root types
 */

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.types = undefined;

var _client = require('./client');

var _client2 = _interopRequireDefault(_client);

var _config = require('./config');

var _config2 = _interopRequireDefault(_config);

var _crypto = require('./crypto');

var _crypto2 = _interopRequireDefault(_crypto);

var _clientDetails = require('./types/clientDetails');

var _clientDetails2 = _interopRequireDefault(_clientDetails);

var _clientInfo = require('./types/clientInfo');

var _clientInfo2 = _interopRequireDefault(_clientInfo);

var _eakInfo = require('./types/eakInfo');

var _eakInfo2 = _interopRequireDefault(_eakInfo);

var _file = require('./types/file');

var _file2 = _interopRequireDefault(_file);

var _incomingSharingPolicy = require('./types/incomingSharingPolicy');

var _incomingSharingPolicy2 = _interopRequireDefault(_incomingSharingPolicy);

var _keyPair = require('./types/keyPair');

var _keyPair2 = _interopRequireDefault(_keyPair);

var _meta = require('./types/meta');

var _meta2 = _interopRequireDefault(_meta);

var _outgoingSharingPolicy = require('./types/outgoingSharingPolicy');

var _outgoingSharingPolicy2 = _interopRequireDefault(_outgoingSharingPolicy);

var _publicKey = require('./types/publicKey');

var _publicKey2 = _interopRequireDefault(_publicKey);

var _query = require('./types/query');

var _query2 = _interopRequireDefault(_query);

var _queryResult = require('./types/queryResult');

var _queryResult2 = _interopRequireDefault(_queryResult);

var _record = require('./types/record');

var _record2 = _interopRequireDefault(_record);

var _recordData = require('./types/recordData');

var _recordData2 = _interopRequireDefault(_recordData);

var _recordInfo = require('./types/recordInfo');

var _recordInfo2 = _interopRequireDefault(_recordInfo);

var _serializable = require('./types/serializable');

var _serializable2 = _interopRequireDefault(_serializable);

var _signable = require('./types/signable');

var _signable2 = _interopRequireDefault(_signable);

var _signedDocument = require('./types/signedDocument');

var _signedDocument2 = _interopRequireDefault(_signedDocument);

var _signedString = require('./types/signedString');

var _signedString2 = _interopRequireDefault(_signedString);

var _signingKey = require('./types/signingKey');

var _signingKey2 = _interopRequireDefault(_signingKey);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var ClientInterface = {
  Client: _client2.default,
  Config: _config2.default,
  Crypto: _crypto2.default
};exports.default = ClientInterface;

/**
 * Primitive types
 */

var types = exports.types = {
  ClientDetails: _clientDetails2.default,
  ClientInfo: _clientInfo2.default,
  EAKInfo: _eakInfo2.default,
  File: _file2.default,
  IncomingSharingPolicy: _incomingSharingPolicy2.default,
  KeyPair: _keyPair2.default,
  Meta: _meta2.default,
  OutgoingSharingPolicy: _outgoingSharingPolicy2.default,
  PublicKey: _publicKey2.default,
  Query: _query2.default,
  QueryResult: _queryResult2.default,
  Record: _record2.default,
  RecordData: _recordData2.default,
  RecordInfo: _recordInfo2.default,
  Serializable: _serializable2.default,
  Signable: _signable2.default,
  SignedDocument: _signedDocument2.default,
  SignedString: _signedString2.default,
  SigningKey: _signingKey2.default
};