"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _entries = require("babel-runtime/core-js/object/entries");

var _entries2 = _interopRequireDefault(_entries);

var _getIterator2 = require("babel-runtime/core-js/get-iterator");

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var File = function () {
  /* eslint-disable max-params */
  function File(checksum, compression, size, writerId, userId, recordType) {
    var plain = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : {};
    var fileUrl = arguments.length > 7 && arguments[7] !== undefined ? arguments[7] : null;
    var fileName = arguments.length > 8 && arguments[8] !== undefined ? arguments[8] : null;
    var recordId = arguments.length > 9 && arguments[9] !== undefined ? arguments[9] : null;
    var created = arguments.length > 10 && arguments[10] !== undefined ? arguments[10] : null;
    var lastModified = arguments.length > 11 && arguments[11] !== undefined ? arguments[11] : null;
    var version = arguments.length > 12 && arguments[12] !== undefined ? arguments[12] : null;
    (0, _classCallCheck3.default)(this, File);

    // Empty dict for data.
    this.data = {};
    // Base64 encoded MD5 Checksum of the Encrypted File, including E3DB Header information
    this.checksum = checksum;
    // The type of compression the file is using, before encryption. Reserved for future use.
    this.compression = compression;
    // Size of the encrypted file, in bytes, including E3DB Header information
    this.size = size;
    this.writerId = writerId;
    this.userId = userId;
    this.recordType = recordType;
    // Optional. Signed url used for PUT/GET to storage server
    this.fileUrl = fileUrl;
    // Optional. Name of the file stored on the server. File name consists of UUID + timestamp. Returned by the server after the file has been uploaded.
    this.fileName = fileName;
    // Optional. ID of the Record in a UUID format. Returned by the server after the file has been uploaded.
    this.recordId = recordId;
    // Optional. Created timestamp of the file, returned by the server after the file has been uploaded.
    this.created = created;
    // Optional. Last Modified timestamp of the file, returned by the server after the file has been uploaded.
    this.lastModified = lastModified;
    // Optional. The version of the file based on File structure and cryptographic methods.
    this.version = version;
    // Optional. Plaintext metadata attached to the File.
    this.plain = plain;
  }
  /* eslint-enable maxparams */

  (0, _createClass3.default)(File, [{
    key: "removeEmpty",
    value: function removeEmpty(obj) {
      /*
      Parameters
      ----------
      serialize: dict
        Dictionary to remove empty elements from
      Returns
      -------
      dict
        Dictionary with empty elements removed
      */
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = (0, _getIterator3.default)((0, _entries2.default)(obj)), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var _ref = _step.value;

          var _ref2 = (0, _slicedToArray3.default)(_ref, 2);

          var key = _ref2[0];
          var val = _ref2[1];

          if (val instanceof Object) {
            this.removeEmpty(val);
          } else if (!val) {
            delete obj[key];
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      return obj;
    }
  }, {
    key: "toJson",
    value: function toJson() {
      /*
      Serialize the configuration as JSON-style object.
      Parameters
      ----------
      None
      Returns
      -------
      dict
        JSON-style document containing the Meta elements.
      */
      /* eslint-disable camelcase */
      var jsonRep = {
        meta: {
          record_id: this.recordId,
          writer_id: this.writerId,
          user_id: this.userId,
          type: this.recordType,
          created: this.created,
          last_modified: this.lastModified,
          version: this.version,
          file_meta: {
            file_url: this.fileUrl,
            file_name: this.fileName,
            checksum: this.checksum,
            compression: this.compression,
            size: parseInt(this.size, 10)
          },
          plain: this.plain
        },
        data: this.data
        /* eslint-enable camelcase */

        // Remove None (JSON null) objects
      };return this.removeEmpty(jsonRep);
    }
  }]);
  return File;
}();

exports.default = File;