/*!
 * Tozny e3db
 *
 * LICENSE
 *
 * Tozny dual licenses this product. For commercial use, please contact
 * info@tozny.com. For non-commercial use, this license permits use of the
 * software only by government agencies, schools, universities, non-profit
 * organizations or individuals on projects that do not receive external
 * funding other than government research grants and contracts. Any other use
 * requires a commercial license. For the full license, please see LICENSE.md,
 * in this source repository.
 *
 * @copyright Copyright (c) 2018-19 Tozny, LLC (https://tozny.com)
 */

'use strict';

/**
 * Base64URL encoded representaion of a public/private keypair
 *
 * @property {string} publicKey  Base64URL encoded public key component
 * @property {string} privateKey Base64URL encoded private key component
 */

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var KeyPair = function KeyPair(publicKey, privateKey) {
  (0, _classCallCheck3.default)(this, KeyPair);

  this.publicKey = publicKey;
  this.privateKey = privateKey;
};

exports.default = KeyPair;