/*!
 * Tozny e3db
 *
 * LICENSE
 *
 * Tozny dual licenses this product. For commercial use, please contact
 * info@tozny.com. For non-commercial use, this license permits use of the
 * software only by government agencies, schools, universities, non-profit
 * organizations or individuals on projects that do not receive external
 * funding other than government research grants and contracts. Any other use
 * requires a commercial license. For the full license, please see LICENSE.md,
 * in this source repository.
 *
 * @copyright Copyright (c) 2018-19 Tozny, LLC (https://tozny.com)
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _signable = require('./signable');

var _signable2 = _interopRequireDefault(_signable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* eslint-disable camelcase */

/**
 * Represents a signed, encrypted documents
 *
 * @property {object} clientMeta
 * @property {object} recordData
 */
var RecordInfo = function (_Signable) {
  (0, _inherits3.default)(RecordInfo, _Signable);

  function RecordInfo(clientMeta, recordData) {
    (0, _classCallCheck3.default)(this, RecordInfo);

    var _this = (0, _possibleConstructorReturn3.default)(this, (RecordInfo.__proto__ || (0, _getPrototypeOf2.default)(RecordInfo)).call(this));

    _this.clientMeta = {
      plain: clientMeta.plain,
      type: clientMeta.type,
      user_id: clientMeta.userId,
      writer_id: clientMeta.writerId
    };
    _this.recordData = recordData;
    return _this;
  }

  /* eslint-enabled */

  /**
   * Serialize the object to JSON
   *
   * @returns {string}
   */


  (0, _createClass3.default)(RecordInfo, [{
    key: 'stringify',
    value: function stringify() {
      return (0, _stringify2.default)(this.clientMeta) + (0, _stringify2.default)(this.recordData);
    }
  }]);
  return RecordInfo;
}(_signable2.default);

exports.default = RecordInfo;