/*!
 * Tozny e3db
 *
 * LICENSE
 *
 * Tozny dual licenses this product. For commercial use, please contact
 * info@tozny.com. For non-commercial use, this license permits use of the
 * software only by government agencies, schools, universities, non-profit
 * organizations or individuals on projects that do not receive external
 * funding other than government research grants and contracts. Any other use
 * requires a commercial license. For the full license, please see LICENSE.md,
 * in this source repository.
 *
 * @copyright Copyright (c) 2018-19 Tozny, LLC (https://tozny.com)
 */

'use strict';

/**
 * Interface for serializable (offline-signable) documents to implement
 */

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Serializable = function () {
  function Serializable() {
    (0, _classCallCheck3.default)(this, Serializable);
  }

  (0, _createClass3.default)(Serializable, [{
    key: 'serializable',

    /**
     * Generate a JSON.stringify-friendly version of the object
     * automatically omitting any `null` fields.
     *
     * @returns {object}
     */
    value: function serializable() {
      throw new Error('Object must implement serializable().');
    }

    /**
     * Serialize the object to JSON
     *
     * @returns {string}
     */

  }, {
    key: 'stringify',
    value: function stringify() {
      return (0, _stringify2.default)(this.serializable());
    }
  }]);
  return Serializable;
}();

exports.default = Serializable;