/*!
 * Tozny e3db
 *
 * LICENSE
 *
 * Tozny dual licenses this product. For commercial use, please contact
 * info@tozny.com. For non-commercial use, this license permits use of the
 * software only by government agencies, schools, universities, non-profit
 * organizations or individuals on projects that do not receive external
 * funding other than government research grants and contracts. Any other use
 * requires a commercial license. For the full license, please see LICENSE.md,
 * in this source repository.
 *
 * @copyright Copyright (c) 2018-19 Tozny, LLC (https://tozny.com)
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _stringify = require('babel-runtime/core-js/json/stringify');

var _stringify2 = _interopRequireDefault(_stringify);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _getIterator2 = require('babel-runtime/core-js/get-iterator');

var _getIterator3 = _interopRequireDefault(_getIterator2);

var _keys = require('babel-runtime/core-js/object/keys');

var _keys2 = _interopRequireDefault(_keys);

var _serializable = require('./serializable');

var _serializable2 = _interopRequireDefault(_serializable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Recursively sort an object by its keys so we have a deterministic
 * output of the data when serialized. Keys are sorted by byte order first,
 * then a new object is created and populated with copies of the incoming object's
 * data (but using the new, sorted key order for insertion).
 *
 * If a value within the object is itself an object, the nested object will first
 * be sorted itself before being inserted into the new parent object.
 *
 * @param {object} obj Object to sort
 *
 * @returns {object}
 */
function sortObject(obj) {
  var keys = (0, _keys2.default)(obj);
  keys.sort();

  var returner = {};
  var _iteratorNormalCompletion = true;
  var _didIteratorError = false;
  var _iteratorError = undefined;

  try {
    for (var _iterator = (0, _getIterator3.default)(keys), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
      var key = _step.value;

      if (obj[key] instanceof Object) {
        returner[key] = sortObject(obj[key]);
      } else {
        returner[key] = obj[key];
      }
    }
  } catch (err) {
    _didIteratorError = true;
    _iteratorError = err;
  } finally {
    try {
      if (!_iteratorNormalCompletion && _iterator.return) {
        _iterator.return();
      }
    } finally {
      if (_didIteratorError) {
        throw _iteratorError;
      }
    }
  }

  return returner;
}

/**
 * Interface for serializable (offline-signable) documents to implement
 */

var Signable = function (_Serializable) {
  (0, _inherits3.default)(Signable, _Serializable);

  function Signable() {
    (0, _classCallCheck3.default)(this, Signable);
    return (0, _possibleConstructorReturn3.default)(this, (Signable.__proto__ || (0, _getPrototypeOf2.default)(Signable)).apply(this, arguments));
  }

  (0, _createClass3.default)(Signable, [{
    key: 'serializable',

    /**
     * Generate a JSON.stringify-friendly version of the object
     * automatically omitting any `null` fields.
     *
     * @returns {object}
     */
    value: function serializable() {
      return this;
    }

    /**
     * Serialize the object to JSON.
     *
     * Internally, JSON.stringify() will serialize keys in chronological order (the
     * order in which they were added to the object). For deterministic signing,
     * however, we want to ensure the keys are in ascending byte order instead. To
     * achieve this, the object is passed into a recursive sorting mechanism that
     * will create a _new_ object, then copy values from the existing object into it,
     * but in the proper order. That object is then passed through the native
     * JSON.stringify method to serialize everything as expected.
     *
     * @returns {string}
     */

  }, {
    key: 'stringify',
    value: function stringify() {
      return (0, _stringify2.default)(sortObject(this.serializable()));
    }
  }]);
  return Signable;
}(_serializable2.default);

exports.default = Signable;