/*!
 * Tozny e3db
 *
 * LICENSE
 *
 * Tozny dual licenses this product. For commercial use, please contact
 * info@tozny.com. For non-commercial use, this license permits use of the
 * software only by government agencies, schools, universities, non-profit
 * organizations or individuals on projects that do not receive external
 * funding other than government research grants and contracts. Any other use
 * requires a commercial license. For the full license, please see LICENSE.md,
 * in this source repository.
 *
 * @copyright Copyright (c) 2018-19 Tozny, LLC (https://tozny.com)
 */

'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _signable = require('./signable');

var _signable2 = _interopRequireDefault(_signable);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Represents a signed document with an attached signature
 *
 * @property {Serializable} document
 * @property {string}       signature
 */
var SignedDocument = function (_Signable) {
  (0, _inherits3.default)(SignedDocument, _Signable);

  function SignedDocument(document, signature) {
    (0, _classCallCheck3.default)(this, SignedDocument);

    var _this = (0, _possibleConstructorReturn3.default)(this, (SignedDocument.__proto__ || (0, _getPrototypeOf2.default)(SignedDocument)).call(this));

    _this.document = document;
    _this.signature = signature;
    return _this;
  }

  /**
   * Generate a JSON.stringify-friendly version of the object
   * automatically omitting any `null` fields.
   *
   * @returns {object}
   */


  (0, _createClass3.default)(SignedDocument, [{
    key: 'serializable',
    value: function serializable() {
      var toSerialize = {
        doc: this.document,
        sig: this.signature
      };

      return toSerialize;
    }

    /**
     * Specify how an already unserialized JSON array should be marshaled into
     * an object representation.
     *
     * <code>
     * signedDocument = SignedDocument.decode({
     *   'doc': {},
     *   'sig': {}
     * })
     * </code>
     *
     * @param {object} json
     *
     * @return {Promise<SignedDocument>}
     */

  }], [{
    key: 'decode',
    value: function decode(json) {
      var signedDocument = new SignedDocument(json.doc, json.sig);

      return _promise2.default.resolve(signedDocument);
    }
  }]);
  return SignedDocument;
}(_signable2.default);

exports.default = SignedDocument;